uses dos;

{
  Simple APM PowerDown for Dos
  Armin Diehl 12/2004
  can be compiled with Turbo Pascal 7

  To power off a netware server after nutmon has done a server
  shutdown, place APMPWOFF -f c:\poweroff in the autoexec.bat
  after server:

  @echo off
  cd \nwserver
  server -nl
  cd ..
  apmpwoff -f \poweroff

  and add CreatePowerOffFile=c:\poweroff
  to nutmon.ini

  In case nutmon does a shudown it will create the file
  c:\poweroff. APMPWOFF with the -f \poweroff flag will only
  power off the system if this file exists.
}

var apmverl,apmverh,lastError:byte;

{------------------------------------------------}

procedure flush_smartdrv;
var r : registers;
begin
  r.ax := $4a10;
  r.bx := 0;
  r.cx := $ebab;
  intr ($2f,r);
  if r.ax = $babe then
  begin
    writeln ('flushing SmartDrv cache');
    r.ax := $4a10;
    r.bx := 1;
    intr ($2f,r);
  end;
end;

{------------------------------------------------}

function apm_installed : boolean;
var r : registers;
begin
  r.ax := $5300;
  r.bx := 0;
  intr ($15,r);
  if (r.flags and fCarry = 0) then
  begin
    apmverh := r.ah;
    apmverl := r.al;
    apm_installed := true;
  end else
    apm_installed := false;
end;

procedure apm_driverversion;
var r : registers;
begin
  if ((apmverh = 1) and (apmverl >= 1)) or (apmverh > 1) then
  begin
    r.ax := $530e;
    {r.cx := $0101;}  {request apm 1.1}
    r.ch := apmverh;
    r.cl := apmverl;
    r.bx := 0;
    intr ($15,r);
    if (r.flags and fCarry <> 0) then
    begin
      writeln ('Warning: set driver version ',apmverh,'.',apmverl,' failed with error ',r.ah);
    end;
  end;
end;


function apm_connect : boolean;
var r : registers;
begin
  r.ax := $5301;
  r.bx := 0;
  intr ($15,r);
  apm_connect := (r.flags and fCarry = 0);
  lastError := r.ah;
end;


function apm_poweroff:boolean;
var r : registers;
begin
  r.ax := $5307;
  r.bx := 1;  {device=all}
  r.cx := 3;  {off}
  intr ($15,r);
  apm_poweroff := (r.flags and fCarry = 0);
  lastError := r.ah;
end;

procedure apm_disconnect;
var r : registers;
begin
  r.ax := $5304;
  r.bx := 0;
  intr ($15,r);
end;

procedure handle_params;
var s : SearchRec;
begin
  if paramcount = 0 then exit;
  if (paramcount = 2) and ((paramstr(1) = '-f') or (paramstr(1) = '-F')) then
  begin
    findfirst (paramstr(2),anyFile,s);
    if doserror <> 0 then halt(3);
    exit;
  end;
  writeln ('APMPWOFF without parameters will simply power off the machine');
  writeln ('APMPWOFF -f filename will only power off if the specified filename exists');
  halt(4);
end;

begin
  writeln('APM Power Off, Armin Diehl <armin@freepascal.net> dec 2004');
  handle_params;
  if apm_installed then
  begin
    writeln ('APM ',apmverh,'.',apmverl,' found');
    if not apm_connect then
    begin
      writeln ('APM connect failed (Err:',lastError,')');
      halt(2);
    end;
    if (apmverh = 1) and (apmverl = 0) then
      writeln ('Warning: APM 1.0 may not support Power Off');
    apm_driverversion;  {if not set, apm assumes 1.0}
    flush_smartdrv;
    if not apm_poweroff then
    begin
      writeln ('APM poweroff failed (Err:',lastError,')');
      apm_disconnect;
      halt(3);
    end;
  end else
  begin
    writeln ('no APM bios found');
    halt (1);
  end;
end.
